cr .( eforth body ) cr

: :: code doLIST jsp ;
: ;; EXIT ;
: USER code doCON jsp #, ;

OCTAL 
10 USER HLD
11 USER SPAN
12 USER >IN
13 USER #TIB
14 USER BASE
15 USER CP
16 USER CONTEXT
17 USER LAST
20 USER 'EVAL
\ 21 USER 'ABORT
27 USER TMP
27 USER tmp
HEX
$F80 USER TIB
$F20 USER TEXT

CRR .( IO ) CRR
0 CONSTANT gpio_o
1 CONSTANT gpio_dir
3 CONSTANT gpio_i
4 CONSTANT uart_i ( baudrate )
5 CONSTANT uart_t ( tx_en/tx_buffer )
6 CONSTANT uart_r ( rxb_full )
7 CONSTANT uart_o ( rx_buffer_reg )

CODE KEY ( -- c )
        BEGIN uart_r iotr szan jmp
	uart_o iotr ac dac 
	pushs ac lac tos dac next
CODE EMIT ( c -- )
        BEGIN uart_t iotr szan jmp
        tos lac uart_t iotw 
	pops next
CODE IN ( -- c )
        pushs gpio_i iotr tos dac next
CODE OUT ( c -- )
        tos lac gpio_o iotw
	pops next
CODE DIR ( c -- )
        tos lac gpio_dir iotw
	pops next

CRR .( high level ) CRR

:: ROT ( w1 w2 w3 -- w2 w3 w1 )
	>R SWAP R> SWAP ;;
:: 2DROP ( w w  -- )
	DROP DROP ;;
:: 2DUP ( w1 w2 -- w1 w2 w1 w2 )
	OVER OVER ;;
:: 2! ( d a -- )
	SWAP OVER ! 1+ ! ;;
:: 2@ ( a -- d )
	DUP @ SWAP 1+ @ SWAP ;;
:: DNEGATE ( d -- -d )
	NOT >R NOT 1 LIT UM+
	R> + ;;

CRR .( Common functions ) CRR
:: U< ( u u -- t ) 2DUP XOR 0< IF SWAP DROP 0< EXIT THEN - 0< ;;
::  < ( n n -- t ) 2DUP XOR 0< IF      DROP 0< EXIT THEN - 0< ;;
:: MAX ( n n -- n ) 2DUP      < IF SWAP THEN DROP ;;
:: MIN ( n n -- n ) 2DUP SWAP < IF SWAP THEN DROP ;;
:: WITHIN ( u ul uh -- t ) \ ul <= u < uh
   OVER - >R - R> U< ;;

CRR .( Divide ) CRR
CODE UM/MOD ( ud u -- ur uq )
   sp () lac ac dac sp idx
   sp () lio ac lac
   skip
CODE /MOD ( n n -- r q )
   sp () lio cla
   then
   tos dis tos dis tos dis tos dis
   tos dis tos dis tos dis tos dis
   tos dis tos dis tos dis tos dis
   tos dis tos dis tos dis tos dis
   tos dis tos dis tos dis sar
   sp () dac tos dio next
:: MOD ( n n -- r )
   /MOD DROP ;;
:: / ( n n -- q )
   /MOD SWAP DROP ;;
:: M/MOD ( d n -- r q ) \ floored
  DUP 0<  DUP >R
  IF NEGATE >R DNEGATE R>
  THEN >R DUP 0< IF R@ + THEN R> UM/MOD R>
  IF SWAP NEGATE SWAP THEN ;;

CRR .( Multiply ) CRR
CODE UM* ( u u -- ud )
   sp () lio cla
   tos mus tos mus tos mus tos mus
   tos mus tos mus tos mus tos mus
   tos mus tos mus tos mus tos mus
   tos mus tos mus tos mus tos mus
   tos mus tos mus 
   tos dac sp () dio next

:: * ( n n -- n ) UM* DROP ;;
:: M* ( n n -- d )
  2DUP XOR 0< >R  ABS SWAP ABS UM*  R> IF DNEGATE THEN ;;
:: */MOD ( n n n -- r q ) >R M* R> M/MOD ;;
:: */ ( n n n -- q ) */MOD SWAP DROP ;;

CRR .( Bits & Bytes ) CRR
:: >CHAR ( c -- c )
  $7F LIT AND DUP $7F LIT BL WITHIN
  IF DROP ( CHAR _ ) $5F LIT THEN ;;

CRR .( Memory access ) CRR
:: HERE ( -- a ) CP @ ;;
:: PAD ( -- a ) HERE 50 LIT + ;;

CRR
:: @EXECUTE ( a -- ) @ ?DUP IF EXECUTE THEN ;;
:: CMOVE ( b b u -- )
  FOR AFT >R DUP @ R@ ! 1+ R> 1+ THEN NEXT 2DROP ;;
:: FILL ( b u c -- )
  SWAP FOR SWAP AFT 2DUP ! 1+ THEN NEXT 2DROP ;;

CRR HEX

:: PACK$ ( b u a -- a ) \ null fill
   2DUP !
   DUP >R SWAP 1 LIT TMP ! 
   FOR AFT ( b a )
      B> TMP @
      IF   0 LIT TMP ! 1+ 0 LIT OVER !
      ELSE 1 LIT TMP ! 
      THEN
   THEN NEXT
   TMP @ IF DUP @ SHL8 OVER ! THEN
   2DROP R>
  ;;
:: UNPACK$ ( a b -- b )
  DUP >R ( save b )
  >B R@ @ $1F LIT AND 2/
  FOR AFT
    >B 
  THEN NEXT
  2DROP R>
  ;;
:: UNPACK ( a b -- b )
  DUP >R ( save b )
  >B R@ @ $FF LIT AND 2/
  FOR AFT
    >B 
  THEN NEXT
  2DROP R>
  ;;


CRR .( Numeric Output ) CRR \ single precision
:: DIGIT ( u -- c )
  9 LIT OVER < 7 LIT AND +
  ( CHAR 0 ) 30 LIT + ;;
:: EXTRACT ( n base -- n c )
  0 LIT SWAP UM/MOD SWAP DIGIT ;;
:: <# ( -- ) PAD HLD ! ;;
:: HOLD ( c -- ) HLD @ 1- DUP HLD ! ! ;;
:: # ( u -- u ) BASE @ EXTRACT HOLD ;;
:: #S ( u -- 0 ) BEGIN # DUP WHILE REPEAT ;;
CRR
:: SIGN ( n -- ) 0< IF ( CHAR - ) 2D LIT HOLD THEN ;;
:: #> ( w -- b u ) DROP HLD @ PAD OVER - ;;
:: str ( n -- b u ) DUP >R ABS <# #S R> SIGN #> ;;
:: HEX ( -- ) 10 LIT BASE ! ;;
:: OCTAL ( -- ) 8 LIT BASE ! ;;
:: DECIMAL ( -- ) 0A LIT BASE ! ;;

CRR .( Numeric Input ) CRR \ single precision
:: DIGIT? ( c base -- u t )
  >R ( CHAR 0 ) 30 LIT - 9 LIT OVER <
  IF 7 LIT - DUP 0A LIT  < OR THEN DUP R> U< ;;
:: NUMBER? ( a -- n T | a F )
  BASE @ >R  0 LIT OVER COUNT ( a 0 b n)
  OVER @ ( CHAR $ ) 24 LIT =
  IF HEX SWAP 1+ SWAP 1- THEN ( a 0 b' n')
  OVER @ ( CHAR - ) 2D LIT = >R ( a 0 b n)
  SWAP R@ - SWAP R@ + ( a 0 b" n") ?DUP
  IF 1- ( a 0 b n)
    FOR DUP >R @ BASE @ DIGIT?
      WHILE SWAP BASE @ * +  R> 1+
    NEXT DROP R@ ( b ?sign) IF NEGATE THEN SWAP
      ELSE R> R> ( b index) 2DROP ( digit number) 2DROP 0 LIT
      THEN DUP
  THEN R> ( n ?sign) 2DROP R> BASE ! ;;

CRR .( Basic I/O ) CRR
:: SPACE ( -- ) BL EMIT ;;
:: CHARS ( +n c -- )
  SWAP 0 LIT MAX
  FOR AFT DUP EMIT THEN NEXT DROP ;;
:: SPACES ( +n -- ) BL CHARS ;;
:: TYPE ( b u -- )
  FOR AFT DUP @ >CHAR EMIT 1+
  THEN NEXT DROP ;;
:: CR ( -- ) ( =Cr )
  0A LIT 0D LIT EMIT EMIT ;;
:: do$ ( -- a )
  R> R@ 1+ TEXT UNPACK
  R> TEXT @ 2/ 1+ +
  >R SWAP >R ;;

CRR
:: $"| ( -- a ) do$ ;; 
:: ."| ( -- ) do$ COUNT TYPE ;;
::  .R ( n +n -- )
  >R str      R> OVER - SPACES TYPE ;;
:: U.R ( u +n -- )
  >R <# #S #> R> OVER - SPACES TYPE ;;
:: U. ( u -- ) <# #S #> SPACE TYPE ;;
::  . ( n -- )
  BASE @ 0A LIT  XOR
  IF U. EXIT THEN str SPACE TYPE ;;
:: ? ( a -- ) @ . ;;

CRR .( Parsing ) CRR
:: (parse) ( b u c -- b u delta ; <string> )
  TMP ! OVER >R DUP \ b u u
  IF 1- TMP @ BL =
    IF              \ b u' \ 'skip'
      FOR BL OVER @ - 0< NOT
        WHILE 1+
      NEXT ( b) R> DROP 0 LIT DUP EXIT \ all delim
        THEN  R>
    THEN OVER SWAP  \ b' b' u' \ 'scan'
    FOR TMP @ OVER @ -  TMP @ BL =
      IF 0< THEN WHILE 1+
    NEXT DUP >R
      ELSE R> DROP DUP 1+ >R
      THEN OVER -  R>  R> - EXIT
  THEN ( b u) OVER R> - ;;
:: PARSE ( c -- b u ; <string> )
  >R  TIB >IN @ +
  #TIB @ >IN @ -
  R> (parse) >IN +! ;;
:: TOKEN ( -- a ;; <string> )
  BL PARSE 1F LIT MIN 2DUP
  DUP TEXT ! TEXT 1+ SWAP CMOVE
  HERE 1+ PACK$ ;;
:: WORD ( c -- a ; <string> )
  PARSE HERE 1+ PACK$ ;;

CRR .( Dictionary Search ) CRR
:: NAME> ( a -- xt )
  COUNT SHR8 $1F LIT AND 2/ + ;;
:: SAME? ( a a u -- a a f \ -0+ )
  2/
  FOR AFT OVER R@ + @
    OVER R@ + @ - ?DUP
    IF R> DROP EXIT THEN
  THEN NEXT
  0 LIT ;;
:: find ( a va -- xt na | a F )
  SWAP         \ va a
  DUP @ SHR8 TMP !  \ va a  \ get cell count
  DUP @ >R     \ va a  \ count
  1+ SWAP      \ a' va
  BEGIN @ DUP  \ a' na na
    IF DUP @ $1FFF LIT AND
      R@ XOR \ ignore lexicon bits
      IF 1+ -1 LIT
      ELSE 1+ TMP @ SAME?
      THEN
    ELSE R> DROP SWAP 1- SWAP EXIT \ a F
    THEN
  WHILE 1- 1-  \ a' la
  REPEAT R> DROP SWAP DROP
  1- DUP NAME> SWAP ;;
:: NAME? ( a -- xt na | a F )
  CONTEXT find ;;

CRR .( Terminal ) CRR
:: ^H ( b b b -- b b b ) \ backspace
  >R OVER R> SWAP OVER XOR
  IF ( =BkSp ) 8 LIT EMIT
     1-         BL EMIT \ distructive
     ( =BkSp ) 8 LIT EMIT \ backspace
  THEN ;;
:: TAP ( bot eot cur c -- bot eot cur )
  DUP EMIT OVER ! 1+ ;;
:: kTAP ( bot eot cur c -- bot eot cur )
  DUP ( =Cr ) 0D LIT XOR
  IF ( =BkSp ) 8 LIT XOR
    IF BL TAP ELSE ^H THEN
    EXIT
  THEN DROP SWAP DROP DUP ;;

CRR
:: accept ( b u -- b u )
  OVER + OVER
  BEGIN 2DUP XOR
  WHILE  KEY  DUP BL -  5F LIT U<
    IF TAP ELSE kTAP THEN
  REPEAT DROP  OVER - ;;
:: EXPECT ( b u -- ) accept SPAN ! DROP ;;
:: QUERY ( -- )
  TIB 50 LIT accept #TIB !
  DROP 0 LIT >IN ! ;;

CRR .( Error handling ) CRR
:: ABORT ( -- ) SP0 SKIP \ jump forward to QUIT
:: abort" ( f -- )
  IF do$ COUNT TYPE ABORT THEN do$ DROP ;;

CRR .( Interpret ) CRR
:: ERROR ( a -- )
  DROP SPACE TEXT COUNT TYPE
  $3F LIT EMIT CR ABORT
:: $INTERPRET ( a -- )
  NAME?  ?DUP
  IF @ $10000 LIT AND
    abort" $LIT compile only" EXECUTE EXIT
  THEN DROP TEXT NUMBER?
  IF EXIT THEN ERROR
:: [ ( -- )
  forth_' $INTERPRET  >body forth_@ LIT 'EVAL !
  ;; IMMEDIATE
:: .OK ( -- )
  forth_' $INTERPRET >body forth_@ LIT 'EVAL @ =
  IF CR >R >R >R >R DUP . R> DUP . R> DUP .
    R> DUP . R> DUP .
    ."| $LIT  > " 
  THEN ;;
:: EVAL ( -- )
  BEGIN TOKEN DUP @
  WHILE 'EVAL @EXECUTE \ ?STACK
  REPEAT DROP .OK ;;

CRR .( Shell ) CRR
:: QUIT ( -- ) 
   THEN \ jump from ABORT
   RP0 ( init rp )
   [ BEGIN QUERY EVAL AGAIN

CRR .( Compiler Primitives ) CRR
:: ' ( -- xt )
  TOKEN NAME? IF EXIT THEN
  ERROR
:: ALLOT ( n -- ) CP +! ;;
:: , ( w -- ) HERE DUP 1+ CP ! ! ;;
:: JMP, ( a -- ) $30000 LIT OR , ;;
:: JSP, ( a -- ) $32000 LIT OR , ;;
:: [COMPILE] ( -- ; <string> )
  '  JMP, ;; IMMEDIATE	

CRR
:: COMPILE ( -- ) R> 1+ DUP @ , >R ;;
:: LITERAL ( n -- )
  forth_' DOLIT >body forth_@ LIT 
  JMP, ,
  ;; IMMEDIATE
:: $," ( -- ) ( CHAR " )
  -1 LIT CP +! $22 LIT WORD
  COUNT SHR8 2/ + CP ! ;;

CRR .( Name Compiler ) CRR
:: ?UNIQUE ( a -- a )
  DUP NAME?
  IF TEXT COUNT TYPE ."| $LIT reDef "
  THEN DROP ;;
:: $,n ( a -- )
  DUP @
  IF ?UNIQUE
    ( na) DUP NAME> CP !
    ( na) DUP LAST ! \ for OVERT
    ( na) 1-
    ( la) CONTEXT @ SWAP ! EXIT
  THEN ERROR

CRR .( FORTH Compiler ) CRR

:: $COMPILE ( a -- )
  NAME? ?DUP
  IF @ $20000 LIT AND
    IF EXECUTE
    ELSE JMP,
    THEN EXIT
  THEN DROP TEXT NUMBER?
  IF LITERAL EXIT
  THEN ERROR
:: OVERT ( -- ) LAST @ CONTEXT ! ;;
:: ; ( -- )
  forth_' EXIT >body forth_@ LIT JMP, [ OVERT ;; IMMEDIATE
:: ] ( -- )
  forth_' $COMPILE >body forth_@ LIT 'EVAL ! ;;
:: : ( -- ; <string> )
  TOKEN $,n ] 
  doLIST LIT JSP, ;;
  ;;

CRR .( Tools ) CRR
:: dm+ ( b u -- b )
  OVER 6 LIT U.R SPACE
  FOR AFT COUNT 7 LIT U.R
  THEN NEXT ;;
:: DUMP ( b -- )
  $10 LIT
  FOR AFT CR 8 LIT dm+
  THEN NEXT DROP ;;

CRR
:: >NAME ( xt -- na | F )
  CONTEXT
  BEGIN @ DUP
  WHILE 2DUP NAME> XOR
    IF 1-
    ELSE SWAP DROP EXIT
    THEN
  REPEAT SWAP DROP ;; 
:: .ID ( a -- )
  TEXT UNPACK$
  COUNT $01F LIT AND TYPE SPACE ;;

CRR 
:: SEE ( -- ; <string> )
  ' CR
  BEGIN
    20 LIT FOR
      DUP @ DUP $3F000 LIT AND
      $30000 LIT XOR
      IF U. SPACE
      ELSE $FFF LIT AND >NAME
        ?DUP IF .ID THEN
      THEN 1+
    NEXT KEY $0D LIT =  \ can't use ESC on terminal
  UNTIL DROP ;;
:: WORDS ( -- )
  CR CONTEXT
  BEGIN @ ?DUP
  WHILE DUP SPACE .ID 
    1-
  REPEAT ;;

CRR .( Hardware reset ) CRR
\ comment:
\ ::   DIAGNOSE     ( - )
\    $65 LIT
\     mask
\ 'F'  prove UM+ 0<         \ carry, TRUE, FALSE
\    0 LIT 0< -2 LIT 0<     \ 0 FFFF
\    UM+ DROP               \ FFFF ( -1)
\    3 LIT UM+ UM+ DROP     \ 3
\    $43 LIT UM+ DROP       \ 'F'
\ 'o' logic: XOR AND OR
\    $4F LIT $6F LIT XOR    \ 20h
\    $F0 LIT AND
\    $4F LIT OR
\ 'r' stack: DUP OVER SWAP DROP
\     8 LIT 6 LIT SWAP
\     OVER XOR 3 LIT AND AND
\     $70 LIT UM+ DROP       \ 'r'
\ 't'-- prove BRANCH ?BRANCH
\     0 LIT IF $3F LIT THEN
\     -1 LIT IF $74 LIT ELSE $21 LIT THEN
\ 'h' -- @ ! test memeory address
\     $68 LIT $7 LIT !
\     $7 LIT @
\ 'M' -- prove >R R> R@
\     $4D LIT >R R@ R> AND
\ 'l'  -- prove 'next' can run
\     61 LIT $A LIT FOR 1 LIT UM+ DROP NEXT
\ 'S' -- prove ldxp, stxp, ldrp, strp
\     $56 LIT -3 LIT
\      $30 LIT tx stxp stxp
\      $30 LIT tx ldxp ldxp
\      $30 LIT pushr strp strp popr pops
\      $30 LIT pushr ldrp ldrp popr pops
\     + \ set ov for UM/MOD
\      EMIT
\ 'emi' -- prove mul, dupy, popy
\     $656D LIT $400 LIT UM*
\     SWAP $100 LIT UM*
\      SWAP pops
\      EMIT EMIT
\ ' C' -- prove div
\     $2043 LIT 0 LIT $100 LIT UM/MOD
\      EMIT EMIT
\     ;;
\ comment;

CRR 
:: COLD ( -- )
\   DIAGNOSE
   CR ."| $LIT PDP1 v"
   1 LIT <# # # ( CHAR . ) $2E LIT HOLD # #> TYPE
   CR ABORT

CRR .( Structures ) CRR
:: BEGIN ( -- a ) HERE ;; IMMEDIATE
:: THEN ( A -- ) BEGIN SWAP ! ;; IMMEDIATE
:: FOR ( -- a )
   forth_' >R >body forth_@ LIT JMP,
   BEGIN ;; IMMEDIATE
CRR
:: NEXT ( a -- )
   COMPILE DONEXT , ;; IMMEDIATE
:: UNTIL ( a -- )
   COMPILE ?BRANCH , ;; IMMEDIATE
:: AGAIN ( a -- ) 
   COMPILE BRANCH , ;; IMMEDIATE
:: IF ( -- A )   
   COMPILE ?BRANCH BEGIN 0 LIT , ;; IMMEDIATE
CRR
:: AHEAD ( -- A )
   COMPILE BRANCH BEGIN 0 LIT , ;; IMMEDIATE
:: REPEAT ( A a -- ) AGAIN THEN ;; IMMEDIATE
:: AFT ( a -- a A ) DROP AHEAD BEGIN SWAP ;; IMMEDIATE
:: ELSE ( A -- A )  AHEAD SWAP THEN ;; IMMEDIATE
:: WHEN ( a A -- a A a ) IF OVER ;; IMMEDIATE
:: WHILE ( a -- A a )    IF SWAP ;; IMMEDIATE

CRR
:: ABORT" ( -- ; <string> )
   COMPILE abort" $," ;; IMMEDIATE
:: $" ( -- ; <string> )
   COMPILE $"| $," ;; IMMEDIATE
:: ." ( -- ; <string> ) 
   COMPILE ."| $," ;; IMMEDIATE

CRR
:: CODE ( -- ; <string> )
   TOKEN $,n OVERT ;;
:: CREATE ( -- ; <string> ) 
   CODE doVAR LIT JSP, ;;
:: VARIABLE ( -- ; <string> )
   CREATE 0 LIT , ;;
:: CONSTANT 
   CODE doCON LIT JSP, ;;
:: DOES ( -- )
   R> LAST @ NAME> ! ;;

CRR
:: .( ( -- ) $29 LIT PARSE TYPE ;; IMMEDIATE
:: \ ( -- ) #TIB @ >IN ! ;; IMMEDIATE
:: ( $29 LIT PARSE 2DROP ;; IMMEDIATE
:: IMMEDIATE $20000 LIT LAST +! ;;

CRR
h forth_@
0 org 
forth_' COLD >body forth_@ jmp
$4 #, $31 #, $32 #, $33 #, $34 #, 0 #,

$0C org
$8 #,
              #,
lasth forth_@ #,
lasth forth_@ #,
forth_' $INTERPRET >body forth_@ #,
forth_' QUIT >body forth_@ #,
$EFF #,
$FFF #,
$123 #,
$456 #,
$789 #,


