cr .( kernel, system variables ) cr

HEX

0 1 2 3 4 5
0 debugging? !

OCTAL 
10 CONSTANT HLD
11 CONSTANT SPAN
12 CONSTANT >IN
13 CONSTANT #TIB
14 CONSTANT BASE
15 CONSTANT CP
16 CONSTANT CONTEXT
17 CONSTANT LAST
20 CONSTANT 'EVAL
21 CONSTANT 'ABORT
22 CONSTANT sp
23 CONSTANT rp
24 CONSTANT ip
25 CONSTANT ac
26 CONSTANT tos
27 CONSTANT TMP
27 CONSTANT tmp

30 org

HEX 

cr .( macro words and inner interpresters  ) cr

: pushs ( n -- n n ) sp ddx tos lac sp () dac ;
: pops ( n -- ) sp () lac tos dac sp idx ;
: pushr ( s: n --, r: -- n ) rp ddx tos lac rp () dac pops ;
: popr ( r: n --, s: -- n ) pushs rp () lac tos dac rp idx ;

label doLIST 
	ac dac rp ddx ip lac rp () dac ac lac ip dac ip () jmp
label doCON 
	ac dac pushs ac () lac tos dac 
label doSTEP
	ip idx ip () jmp 
: next doSTEP jmp ;
label doVAR 
	ac dac pushs ac lac tos dac next 

cr .( kernel words ) cr

code BRANCH 
label branch
	ip idx ip () lac ip dac ip () jmp
code ?BRANCH 
	tos lac ac dac pops ac lac szan 
	branch jmp ip idx next 
code DOLIT 
	pushs ip idx ip () lac tos dac next
code EXIT 
	rp () lac ip dac rp idx next 
label leave
	rp idx ip idx next 
code DONEXT 
	rp () dsp leave jmp branch jmp 
code EXECUTE ( a -- ) 
	tos lac ac dac pops ac () jmp

cr .( structure compiler) cr

: begin anew h @ ;
: until szan ( addr ) jmp ;

: if      szan h @ 0 jmp ;  
: skip    h @ 0 jmp ; 
: then    begin OVER ram@ OR SWAP ramOR ;
: else    skip SWAP then ;
: while   if SWAP ;
: repeat  jmp then ;
: again   jmp ;

: BEGIN   begin ;
: UNTIL   ?BRANCH #, ;
: IF      ?BRANCH h @ 0 #, ;  
: SKIP    BRANCH h @ 0 #, ; 
: THEN    BEGIN SWAP ram! ;
: ELSE    SKIP SWAP THEN ;
: WHILE   IF SWAP ;
: REPEAT  BRANCH #, THEN ;
: AGAIN   BRANCH #, ;
: AFT ( a -- a' a" )
   	  DROP SKIP BEGIN SWAP ;
: NEXT    DONEXT #, ;
: LIT     DOLIT #, ;

cr

code ! ( n a -- ) 
	sp () lac tos () dac sp idx pops next
code @ ( a - n ) 
	tos () lac tos dac next
code R> ( - n ) 
	popr next
code R@ ( - n ) 
	pushs rp () lac tos dac next
code >R ( n ) 
	pushr next
code DUP ( n - n n ) 
	pushs next
code SWAP ( n1 n2 - n2 n1 )
   	sp () lac ac dac tos lac sp () dac 
	ac lac tos dac next
code DROP ( w w  -- )
  	pops next
code SP0
	$EFF law sp dac tos dzm next
code RP0
	$FFF law rp dac next

: FOR   >R BEGIN ;

cr
code + ( w w -- w ) 
	sp () lac tos add tos dac sp idx next
code NOT ( w -- w ) 
	tos lac cma tos dac next
code AND 
	sp () lac tos and tos dac sp idx next
code XOR 
	sp () lac tos xor tos dac sp idx next
code OVER 
	sp () lac ac dac pushs ac lac tos dac next
code NEGATE ( n -- -n )
	cla tos sub tos dac next

cr
code 1- ( a -- a )
	tos ddx next
code 1+ ( a -- a )
	tos idx next
code BL ( -- 32 )
	pushs 20 law tos dac next 
code +! ( n a -- )
	sp () lac tos () add tos () dac sp idx
	pops next
code - ( w w -- w )
	sp () lac tos sub tos dac sp idx next
code OR ( n n - n )
	sp () lac tos ior tos dac sp idx next
code COUNT ( b -- b +n )
	pushs sp () idx tos () lac tos dac next
code 2* ( a -- a )
	tos lac sal tos dac next
code 2/ ( a -- a )
	tos lac sar tos dac next

cr
code 0< ( n - f )
	tos lac tos dzm sman tos ddx next
code UM+  ( n n - n carry )
	sp () lac tos add sp () dac
	tos dzm szon tos idx next 
code ?DUP ( w -- w w | 0 )
	tos lac szan next pushs next
code ABS ( n -- +n )
	tos lac spa next cla tos sub tos dac next
code = ( w w -- t )
	sp () lac sp () dzm tos sad sp () ddx pops next 

cr ( pack b> and unpack >b strings )

code B> ( b a -- b+1 a )
	tos () lac sal sal sal sal sal sal sal sal
	tos () dac sp () lac ac dac
	ac () lac tos () ior tos () dac 
	ac idx sp () dac next
code >B ( a b -- a+1 b+2 )
	sp () lac ac dac ac () lac 
	sar sar sar sar sar sar sar sar tos () dac
	tos idx $FF law ac () and tos () dac
	tos idx ac idx sp () dac next
code SHR8
	tos lac
	sar sar sar sar sar sar sar sar
	tos dac next
code SHL8
	tos lac 
	sal sal sal sal sal sal sal sal
	tos dac next
