( meta32.f for weforth, 22mar02cht )

HEX
: OCTAL 8 BASE ! ;

VARIABLE debugging?

: .head ( addr -- addr )
   BASE @ >R OCTAL
   SPACE >IN @ 20 WORD COUNT TYPE >IN !
   DUP . 
   R> BASE !
   ;

: cr CR
   debugging? @
   IF .S KEY 0D = ABORT" DONE"
   THEN
   ;

cr 
: forth_' ' ;
: forth_dup DUP ;
: forth_drop DROP ;
: forth_over OVER ;
: forth_swap SWAP ;
: forth_@ @ ;
: forth_! ! ;
: forth_and AND ;
: forth_+ + ;
: forth_- - ;
: forth_word WORD ;
: forth_words WORDS ;
: forth_.s .S ;
: CRR cr ;
: forth_.( [COMPILE] .( ;
: forth_count COUNT ;
: forth_r> R> ;
: -or   XOR ;
: >body 5 + ;
: forth_forget FORGET ;

cr .( virtual memory ) cr 

CREATE ram  8000 ALLOT
: reset   ram 8000 0 FILL ; 
: ram@   4 * ram +  @ ;
: ram!   4 * ram +  ! ;
: ramOR  DUP >R ram@ OR R> ram! ;
: binary 2 BASE ! ;
: octal 8 BASE ! ;
: hex $10 BASE ! ;
: four   3 FOR DUP ram@ 3FFFF AND 7 U.R 1+ NEXT ;
: show ( a)
   BASE @ >R OCTAL 
   0F FOR CR  DUP 4 U.R $3A EMIT 
   four SPACE SPACE four NEXT 
   R> BASE ! ;
: showram ( a )	
   0 13 FOR show NEXT DROP ;
cr 
: dump-ram
   BASE @ >R OCTAL 0
   $A00 FOR AFT
      CR DUP ram@ <# 1F FOR # NEXT #> TYPE
\      CR DUP ram@ 20 U.R 
      1+
   THEN NEXT
   DROP R> BASE ! CR
   ;
cr 
VARIABLE hFile
: write-log-file
   Z" log.f" 
   $40000000 ( GENERIC_WRITE )
   0 ( share mode )
   0 ( security attribute )
   2 ( CREATE_ALWAYS )
   $80 ( FILE_ATTRIBUTE_NORMAL )
   0 ( hTemplateFile )
   CreateFileA hFile !
   BASE @ HEX
   0 ( initial ram location )
   $1000 FOR AFT
      hFile @ 
      OVER ram@ $3FFFF AND
      <# 0A HOLD 0D HOLD 4 FOR # NEXT #> ( buffer length )
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
      1+
   THEN NEXT
   DROP ( discard ram location )
   hFile @ CloseHandle DROP
   BASE !
   ;
   
CREATE CRLF-ARRAY 0D C, 0A C,
: CRLF   
      hFile @ 
      CRLF-ARRAY 2
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   ;

: open-mem-file
   Z" pdp1.mem" 
   $40000000 ( GENERIC_WRITE )
   0 ( share mode )
   0 ( security attribute )
   2 ( CREATE_ALWAYS )
   $80 ( FILE_ATTRIBUTE_NORMAL )
   0 ( hTemplateFile )
   CreateFileA hFile !
   ;
: write-mem-line
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   CRLF
   ;
: write-mem-header
      hFile @ 
      $" #Format=AddrHex " 
      write-mem-line
      hFile @ 
      $" #Depth=4096 " 
      write-mem-line
      hFile @ 
      $" #Width=18 " 
      write-mem-line
      hFile @ 
      $" #AddrRadix=3 " 
      write-mem-line
      hFile @ 
      $" #DataRadix=3 " 
      write-mem-line
   ;

: write-mem-data
   0 ( initial ram location )
   $1000 FOR AFT
    DUP ram@ IF
      hFile @ 
      OVER
      <# 3A HOLD #S #>
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
      hFile @ 
      OVER ram@ 
      <# #S #>
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
      CRLF
    THEN
      1+
   THEN NEXT
   DROP ( discard ram location )
   ;

: close-mem-file
   hFile @ CloseHandle DROP
   ;

: write-mem-file
   HEX
   open-mem-file
   write-mem-header
   write-mem-data
   close-mem-file
   ;
   
FLOAD asm_pdp1.f 
FLOAD kern_pdp1.f 
FLOAD ef_pdp1.f 
write-log-file
write-mem-file

cr showram cr



